#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.XlsIO;

namespace EssentialXlsIOSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Image = ((System.Drawing.Bitmap)(resources.GetObject("button1.Image")));
			this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.button1.Location = new System.Drawing.Point(464, 72);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "XLS";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(544, 56);
			this.label1.TabIndex = 1;
			this.label1.Text = @"Clicking the button below will result in a new Excel spreadsheet being generated using Essential XlsIO.  At the end of the spreadsheet generation, an option will be provided to view the generated Excel file. Please note that you need to have an Excel viewer installed in order to view the generated Excel file.";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 102);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.button1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Essential XlsIO Sample";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//The instantiation process consists of two steps.

			//Step 1 : Instantiate the spreadsheet creation engine.
			ExcelEngine excelEngine = new ExcelEngine();

			//Step 2 : Instantiate the excel application object.
			IApplication application = excelEngine.Excel;

			//A new workbook is created.[Equivalent to creating a new workbook in MS Excel]
			//The new workbook will have 2 worksheets
			IWorkbook workbook = application.Workbooks.Create(2);

			//The first worksheet object in the worksheets collection is accessed.
			IWorksheet sheet = workbook.Worksheets[0];
			sheet.Name = "First Chart";

			
			//Entering the Datas for the chart
			sheet.Range["A1"].Text = "Texas books Unit sales";
			sheet.Range["A1:D1"].Merge();
			sheet.Range["A1"].CellStyle.Font.Bold = true;

			sheet.Range["B2"].Text = "Jan";
			sheet.Range["C2"].Text = "Feb";
			sheet.Range["D2"].Text = "Mar";

			sheet.Range["A3"].Text = "Austin";
			sheet.Range["A4"].Text = "Dallas";
			sheet.Range["A5"].Text = "Houston";
			sheet.Range["A6"].Text = "San Antonio";

			sheet.Range["B3"].Number = 53.75;
			sheet.Range["B4"].Number = 52.85;
			sheet.Range["B5"].Number = 59.77;
			sheet.Range["B6"].Number = 96.15;

			sheet.Range["C3"].Number = 79.79;
			sheet.Range["C4"].Number = 59.22;
			sheet.Range["C5"].Number = 10.09;
			sheet.Range["C6"].Number = 73.02;

			sheet.Range["D3"].Number = 26.72;
			sheet.Range["D4"].Number = 33.71;
			sheet.Range["D5"].Number = 45.81;
			sheet.Range["D6"].Number = 12.17;
			
			//Adding a New(Embedded chart) to the Worksheet 
			IChartShape shape = sheet.Charts.Add();
			shape.ChartType=ExcelChartType.Area;
			shape.DataRange = sheet.Range["B3:D6"];
			shape.PrimaryCategoryAxis.Title = "City";
			shape.PrimaryValueAxis.Title = "Sales (in Dollars)";
			shape.ChartTitle = "Texas Books Unit Sales";
			shape.HasDataTable = true;
			
			//Setting the Serie Names in a Legend
			IChartSerie serieOne = shape.Series[0];
			serieOne.Name = "Jan";
			IChartSerie serietwo = shape.Series[1];
			serietwo.Name = "Feb";

			//setting different serie type.
			serietwo.SerieType=ExcelChartType.Column_Clustered;

			//setting Back ground color.
			serietwo.SerieFormat.SerieDataFormat.AreaProperties.BackgroundColorIndex=ExcelKnownColors.Pale_blue;

			//setting Line Color.
			serietwo.SerieFormat.SerieDataFormat.LineProperties.LineColor=System.Drawing.Color.IndianRed;

			//setting Line pattern.
			serietwo.SerieFormat.SerieDataFormat.LineProperties.LinePattern=ExcelChartLinePattern.DashDot;

			//Fill pattern.
			serietwo.SerieFormat.SerieDataFormat.AreaProperties.Pattern=ExcelPattern.Percent125Gray;
			
			IChartSerie seriethree = shape.Series[2];
			seriethree.Name = "March";

			//Setting the (Rows & Columns)Property for the Embedded chart.
			shape.BottomRow = 40;
			shape.TopRow = 10;
			shape.LeftColumn = 3;
			shape.RightColumn = 15;
			

			//Saving the workbook to disk.
			workbook.SaveAs("Sample.xls");

			//Close the workbook.
			workbook.Close();

			//No exception will be thrown if there are unsaved workbooks.
			excelEngine.ThrowNotSavedOnDestroy = false;
			excelEngine.Dispose();
	
			//Message box confirmation to view the created spreadsheet.
			if (MessageBox.Show ("Do you want to view the workbook?", "Workbook has been created",
				MessageBoxButtons.YesNo, MessageBoxIcon.Information)
				== DialogResult.Yes) 
			{
				//Launching the Excel file using the default Application.[MS Excel Or Free ExcelViewer]
				System.Diagnostics.Process.Start("Sample.xls");
				//Exit
				this.Close();
			}
			else
			{
				// Exit
				this.Close();
			}
			
		}
	}

}

