#Region "Copyright Syncfusion Inc. 2001 - 2005"
'
'  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
'
'  Use of this code is subject to the terms of our license.
'  A copy of the current license can be obtained at any time by e-mailing
'  licensing@syncfusion.com. Any infringement will be prosecuted under
'  applicable laws. 
'
#End Region


Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports Syncfusion.XlsIO

Namespace EssentialXlsIOSamples
	''' <summary>
	''' Summary description for Form1.
	''' </summary>
	Public Class Form1 : Inherits System.Windows.Forms.Form
		Private WithEvents button1 As System.Windows.Forms.Button
		Private label1 As System.Windows.Forms.Label

		''' <summary>
		''' Required designer variable.
		''' </summary>
		Private components As System.ComponentModel.Container = Nothing

		Public Sub New()
			'
			' Required for Windows Form Designer support
			'
			InitializeComponent()
			'
			' TODO: Add any constructor code after InitializeComponent call
			'
		End Sub

		''' <summary>
		''' Clean up any resources being used.
		''' </summary>
		Protected Overrides Overloads Sub Dispose(ByVal disposing As Boolean)
			If disposing Then
				If Not components Is Nothing Then
					components.Dispose()
				End If
			End If
			MyBase.Dispose(disposing)
		End Sub

		#Region "Windows Form Designer generated code"
		''' <summary>
		''' Required method for Designer support - do not modify
		''' the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
			Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
			Me.button1 = New System.Windows.Forms.Button()
			Me.label1 = New System.Windows.Forms.Label()
			Me.SuspendLayout()
			' 
			' button1
			' 
			Me.button1.Anchor = (System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right)
			Me.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat
			Me.button1.Image = (CType(resources.GetObject("button1.Image"), System.Drawing.Bitmap))
			Me.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight
			Me.button1.Location = New System.Drawing.Point(464, 72)
			Me.button1.Name = "button1"
			Me.button1.TabIndex = 0
			Me.button1.Text = "XLS"
'			Me.button1.Click += New System.EventHandler(Me.button1_Click);
			' 
			' label1
			' 
			Me.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) Or System.Windows.Forms.AnchorStyles.Right)
			Me.label1.Font = New System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, (CByte(0)))
			Me.label1.Name = "label1"
			Me.label1.Size = New System.Drawing.Size(544, 56)
			Me.label1.TabIndex = 1
			Me.label1.Text = "Clicking the button below will result in a new Excel spreadsheet being generated using Essential XlsIO.  At the end of the spreadsheet generation, an option will be provided to view the generated Excel file. Please note that you need to have an Excel viewer installed in order to view the generated Excel file."
			' 
			' Form1
			' 
			Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
			Me.ClientSize = New System.Drawing.Size(544, 102)
			Me.Controls.AddRange(New System.Windows.Forms.Control() { Me.label1, Me.button1})
			Me.Icon = (CType(resources.GetObject("$this.Icon"), System.Drawing.Icon))
			Me.Name = "Form1"
			Me.Text = "Essential XlsIO Sample"
			Me.ResumeLayout(False)

		End Sub
		#End Region

		''' <summary>
		''' The main entry point for the application.
		''' </summary>
		<STAThread> _
		Shared Sub Main()
			Application.Run(New Form1())
		End Sub

		Private Sub button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles button1.Click
			'The instantiation process consists of two steps.

			'Step 1 : Instantiate the spreadsheet creation engine.
			Dim excelEngine As ExcelEngine = New ExcelEngine()

			'Step 2 : Instantiate the excel application object.
			Dim application As IApplication = excelEngine.Excel

			'A new workbook is created.[Equivalent to creating a new workbook in MS Excel]
			'The new workbook will have 2 worksheets
			Dim workbook As IWorkbook = application.Workbooks.Create(2)

			'The first worksheet object in the worksheets collection is accessed.
			Dim sheet As IWorksheet = workbook.Worksheets(0)
			sheet.Name = "First Chart"


			'Entering the Datas for the chart
			sheet.Range("A1").Text = "Texas books Unit sales"
			sheet.Range("A1:D1").Merge()
			sheet.Range("A1").CellStyle.Font.Bold = True

			sheet.Range("B2").Text = "Jan"
			sheet.Range("C2").Text = "Feb"
			sheet.Range("D2").Text = "Mar"

			sheet.Range("A3").Text = "Austin"
			sheet.Range("A4").Text = "Dallas"
			sheet.Range("A5").Text = "Houston"
			sheet.Range("A6").Text = "San Antonio"

			sheet.Range("B3").Number = 53.75
			sheet.Range("B4").Number = 52.85
			sheet.Range("B5").Number = 59.77
			sheet.Range("B6").Number = 96.15

			sheet.Range("C3").Number = 79.79
			sheet.Range("C4").Number = 59.22
			sheet.Range("C5").Number = 10.09
			sheet.Range("C6").Number = 73.02

			sheet.Range("D3").Number = 26.72
			sheet.Range("D4").Number = 33.71
			sheet.Range("D5").Number = 45.81
			sheet.Range("D6").Number = 12.17

			'Adding a New(Embedded chart) to the Worksheet 
			Dim shape As IChartShape = sheet.Charts.Add()
			shape.ChartType=ExcelChartType.Area
			shape.DataRange = sheet.Range("B3:D6")
			shape.PrimaryCategoryAxis.Title = "City"
			shape.PrimaryValueAxis.Title = "Sales (in Dollars)"
			shape.ChartTitle = "Texas Books Unit Sales"
			shape.HasDataTable = True

			'Setting the Serie Names in a Legend
			Dim serieOne As IChartSerie = shape.Series(0)
			serieOne.Name = "Jan"
			Dim serietwo As IChartSerie = shape.Series(1)
			serietwo.Name = "Feb"

			'setting different serie type.
			serietwo.SerieType=ExcelChartType.Column_Clustered

			'setting Back ground color.
			serietwo.SerieFormat.SerieDataFormat.AreaProperties.BackgroundColorIndex=ExcelKnownColors.Pale_blue

			'setting Line Color.
			serietwo.SerieFormat.SerieDataFormat.LineProperties.LineColor=System.Drawing.Color.IndianRed

			'setting Line pattern.
			serietwo.SerieFormat.SerieDataFormat.LineProperties.LinePattern=ExcelChartLinePattern.DashDot

			'Fill pattern.
			serietwo.SerieFormat.SerieDataFormat.AreaProperties.Pattern=ExcelPattern.Percent125Gray

			Dim seriethree As IChartSerie = shape.Series(2)
			seriethree.Name = "March"

			'Setting the (Rows & Columns)Property for the Embedded chart.
			shape.BottomRow = 40
			shape.TopRow = 10
			shape.LeftColumn = 3
			shape.RightColumn = 15


			'Saving the workbook to disk.
			workbook.SaveAs("Sample.xls")

			'Close the workbook.
			workbook.Close()

			'No exception will be thrown if there are unsaved workbooks.
			excelEngine.ThrowNotSavedOnDestroy = False
			excelEngine.Dispose()

			'Message box confirmation to view the created spreadsheet.
			If MessageBox.Show ("Do you want to view the workbook?", "Workbook has been created", MessageBoxButtons.YesNo, MessageBoxIcon.Information) = DialogResult.Yes Then
				'Launching the Excel file using the default Application.[MS Excel Or Free ExcelViewer]
				System.Diagnostics.Process.Start("Sample.xls")
				'Exit
				Me.Close()
			Else
				' Exit
				Me.Close()
			End If

		End Sub
	End Class

End Namespace

